****** Procedury a funkce ******
*FUNCTION kopirovani_tabulky(cCesta)
*LOCAL radek,retezec,pole_1
*CREATE CURSOR transformTabulka (pole_1 c(10),pole_2 c(10),pole_3 c(10),pole_4 c(10),;
	pole_5 c(10),pole_6 c(10),pole_7 c(10),pole_8 c(10),pole_9 c(10),;
	pole_10 c(10),pole_11 c(10),pole_12 c(10),pole_13 c(10),pole_14 c(10),pole_15 c(10))
*APPEND FROM (cCesta) TYPE  DELIMITED WITH TAB 
*CREATE CURSOR tabulka (Tp c(4), Code_one c(3), Code_two c(3), Code_three c(3),;
	Km_poloha n(6,0), Kolej c(4), Draha_cm n(8,0), Klik_cm n(6,0), K_k_cm n(6,0),;
	Vyska_cm n(6,0), V_k_cm n(6,0), Rych_kmh n(6,0), Tr_Ry_kmh n(6,0),;
	Napeti_v n(6,0), Poruchy c(3))
*SELECT transformTabulka 
*GO TOP 
*SCAN
*	APPEND BLANK IN tabulka
*	SELECT tabulka 
*	m.pole_1=ALLTRIM(transformTabulka.pole_1)
*	IF m.pole_1="HRUS" 
*			REPLACE Tp WITH "HRUS",; 
					Kolej WITH transformTabulka.pole_2,;		
					Draha_cm WITH VAL(transformTabulka.pole_3),;		
					Klik_cm WITH VAL(transformTabulka.pole_4),;		
					K_k_cm WITH VAL(transformTabulka.pole_5),;		
					Vyska_cm WITH VAL(transformTabulka.pole_6);		
					V_k_cm WITH VAL(transformTabulka.pole_7),;		
					Rych_kmh WITH VAL(transformTabulka.pole_8),;		
					Tr_Ry_kmh WITH VAL(transformTabulka.pole_9),;		
					Napeti_v WITH VAL(transformTabulka.pole_10)
*	ELSE 
*		IF LEN(m.pole_1)>0 && zde je stozar
*			REPLACE Tp WITH transformTabulka.pole_1,;		
					Code_one WITH transformTabulka.pole_2,;		
					Code_two WITH transformTabulka.pole_3,;		
					Code_three WITH transformTabulka.pole_4,;		
					Km_poloha WITH VAL(transformTabulka.pole_5),;		
					Kolej WITH transformTabulka.pole_6,;		
					Draha_cm WITH VAL(transformTabulka.pole_7),;		
					Klik_cm WITH VAL(transformTabulka.pole_8),;		
					K_k_cm WITH VAL(transformTabulka.pole_9),;		
					Vyska_cm WITH VAL(transformTabulka.pole_10),;		
					V_k_cm WITH VAL(transformTabulka.pole_11),;		
					Rych_kmh WITH VAL(transformTabulka.pole_12),;		
					Tr_Ry_kmh WITH VAL(transformTabulka.pole_13),;		
					Napeti_v WITH VAL(transformTabulka.pole_14),;		
					Poruchy WITH LEFT(transformTabulka.pole_15,3)		
*		ELSE
*			REPLACE	Kolej WITH transformTabulka.pole_2,;		
					Draha_cm WITH VAL(transformTabulka.pole_3),;		
					Klik_cm WITH VAL(transformTabulka.pole_4),;		
					K_k_cm WITH VAL(transformTabulka.pole_5),;		
					Vyska_cm WITH VAL(transformTabulka.pole_6),;		
					V_k_cm WITH VAL(transformTabulka.pole_7),;		
					Rych_kmh WITH VAL(transformTabulka.pole_8),;		
					Tr_Ry_kmh WITH VAL(transformTabulka.pole_9),;		
					Napeti_v WITH VAL(transformTabulka.pole_10),;	
					Poruchy WITH transformTabulka.pole_11			
*		ENDIF 	
*	ENDIF
*ENDSCAN
*SELECT tabulka 
*GO TOP 
*BROWSE  
*ENDFUNC 

FUNCTION NastavSklon
	IF (kmh>0 AND kmh<>NULL)
		MaxR=kmh
	ELSE 
		MaxR=max_rychl	
	ENDIF 
	DO CASE 
		CASE MaxR<11
			MezSklon=MemoSklon10
		CASE MaxR>10 .AND. MaxR<31	
			MezSklon=MemoSklon30
		CASE MaxR>30 .AND. MaxR<61
			MezSklon=MemoSklon60
		CASE MaxR>60 .AND. MaxR<101
			MezSklon=MemoSklon100
		CASE MaxR>100 .AND. MaxR<121
			MezSklon=MemoSklon120
		CASE MaxR>120 .AND. MaxR<161
			MezSklon=MemoSklon160
		CASE MaxR>160 .AND. MaxR<201
			MezSklon=MemoSklon200
		CASE MaxR>200 .AND. MaxR<251
			MezSklon=MemoSklon250
	ENDCASE
ENDFUNC

FUNCTION NastavMAVSklon
	IF (kmh>0 AND kmh<>NULL)
		MaxR=kmh
	ELSE 
		MaxR=max_rychl	
	ENDIF 
	DO CASE 
		CASE MaxR<=100
			MezSklon=5
		CASE MaxR>100 .AND. MaxR<=120	
			MezSklon=4
		CASE MaxR>120 .AND. MaxR<=140
			MezSklon=3.33
		CASE MaxR>140 .AND. MaxR<=160
			MezSklon=2.5
	ENDCASE
ENDFUNC


FUNCTION NastOpotr
	IF (kmh>0 AND kmh<>NULL)
		MaxR=kmh
	ELSE 
		MaxR=max_rychl
	ENDIF 
	if (MaxR<120)
		DO CASE 
			CASE trolej_mm2=80
				mezOpotrebeni=7.2	
			CASE trolej_mm2=100
				mezOpotrebeni=7.8
			CASE trolej_mm2=150
				mezOpotrebeni=8.8
		ENDCASE 
	ELSE
		DO CASE 
			CASE trolej_mm2=80
				mezOpotrebeni=7.6	
			CASE trolej_mm2=100
				mezOpotrebeni=8.7
			CASE trolej_mm2=150
				mezOpotrebeni=10.5
		ENDCASE 
	ENDIF 
	RETURN mezOpotrebeni			
ENDFUNC 

FUNCTION NastOpotrKU
	DO CASE 
		CASE trolej_mm2=80
			mezOpotrebeniKU=8.1	
		CASE trolej_mm2=100
			mezOpotrebeniKU=9
		CASE trolej_mm2=150
			mezOpotrebeniKU=10.5
	ENDCASE 
	RETURN mezOpotrebeniKU			
ENDFUNC 
 
FUNCTION ProcentOpotr
	s=polomer_mm*polomer_mm*ACOS(((OPO_OHL_MM/20)-polomer_mm)/polomer_mm)-((OPO_OHL_MM/20)-polomer_mm)*SQRT(2*polomer_mm*(2*polomer_mm-(OPO_OHL_MM/20))-(2*polomer_mm-(OPO_OHL_MM/20))*(2*polomer_mm-(OPO_OHL_MM/20)))
	RETURN (100.0*s)/trolej_mm2
ENDFUNC



FUNCTION RozdilVys
RozdilVys=(Vyska_cm_b-V_K_cm_b)-(Vyska_cm_a-V_K_cm_a)
RETURN RozdilVys
ENDFUNC 

FUNCTION RozdilVysOHL
RozdilVys=Vys_ohl_cm_b-Vys_ohl_cm_a
RETURN RozdilVys
ENDFUNC 


FUNCTION RozpTP
IF draha_cm_b<draha_cm_a
	RozpTP=((DrahaKonce-draha_cm_a)+draha_cm_b)/100
	DrahaKonce=draha_konce
	KonecUs=.T.
ELSE 
	RozpTP=(draha_cm_b-draha_cm_a)/100
	DrahaKonce=draha_konce
	KonecUs=.F.
ENDIF
RETURN ROUND(RozpTP,1)

FUNCTION SklonTP
	SklonTP=RozdilVys/RozpTP*10
	RETURN ROUND(SklonTP,2)
ENDFUNC 

***vpoet pro protokol sklon mimo mez
FUNCTION SklonTPm
	IF km_poloha2-km_poloha1>100 AND KonecUs
		DELETE 
	ENDIF 
	SklonTP=RozdilVys/RozpTP*10
	RETURN ROUND(SklonTP,2)
ENDFUNC 

FUNCTION ZmSklTP
ZmSklTP=ZmSklTP+sklon_tp
RETURN ROUND(ZmSklTP,2)
ENDFUNC 

PROCEDURE mapaCD
SET DELETED OFF
SELECT radek
SCAN
	***odstrann dvojteky a sla koleje za nzvem seku v map
	usek=radek
	usek=substr(usek,2,AT(" ",usek)-2)
	SELECT Suseky
	SEEK(usek)
	IF NOT FOUND() .and. usek<>"Konecmereni"
		hlaseni="sek  "+usek+" nenalezen"
		WAIT hlaseni window
		SELECT radek
	ELSE
		SELECT radek
		DELETE 
	ENDIF
ENDSCAN
SELECT radek FROM radek WHERE NOT DELETED() INTO CURSOR NenalezenoVMapeCD 
*BROWSE 
REPORT FORM (cCestaProgramu)+"\reports\kontrolamapyscduseky" PREVIEW 
*COPY TO (CestaSestav)+"KontrolaMapaCD"  DELIMITED WITH "" FOR NOT DELETED()
*use
*SELECT Suseky
*USE
SELECT nenalezenovmapecd
USE 
SELECT radek
USE  
ENDPROC 

PROCEDURE MapaTrasa
	IF (USED("mapa") AND USED("trasa"))
		SET DELETED OFF
		SELECT mapa
		SCAN
		***odstrann dvojteky a sla koleje za nzvem seku v map
			usek=radek
			usek=substr(usek,2,AT(" ",usek)-2)
			SELECT trasa
			SEEK(usek)
			IF NOT FOUND() .and. usek<>"Konecmereni"
				hlaseni="sek  "+usek+" nenalezen"
				WAIT hlaseni window
				SELECT mapa
			ELSE
				SELECT mapa
				DELETE
			ENDIF
		ENDSCAN
		SELECT radek FROM mapa WHERE NOT DELETED() INTO CURSOR NeshodaMapyStrasou
*		BROWSE 
		REPORT FORM (cCestaProgramu)+"\reports\kontrolamapystrasou" PREVIEW  
		SELECT trasa
		USE
		SELECT mapa 
		USE 
		SELECT NeshodaMapyStrasou
		USE
	ENDIF  
	IF (USED("mapa")) 
		SELECT mapa
		USE 
	ENDIF 
	IF (USED("trasa"))
		SELECT trasa
		USE 
	ENDIF 
ENDPROC 

PROCEDURE ZmenaKodu
CREATE CURSOR objekty (por_cis n(6), objekt c(4), draha n(8), kod1 c(2), kod2 c(2),;
	 kod3 c(2), poloha n(11,2), soubor c(99))
SELECT mapa
Cislo=1
****prepsani hodnot z kurzoru mapa do kurzoru objekty
SCAN
	IF LEFT(radek,1)=":"
	    Nazev=ALLTRIM(radek)
	ELSE
	    Ret=ALLTRIM(radek)
	    SELECT objekty
	    APPEND BLANK 
	    IF MapaBezKm
	        replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
	        draha WITH VAL(substr(Ret,AT(" ",Ret,1)+1,4)),soubor WITH Nazev
	    ELSE 
	        pol_cm=substr(Ret,AT(" ",Ret,5)+1,8)
	        replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
	        draha WITH VAL(substr(Ret,AT(" ",Ret,1)+1,4)),soubor WITH Nazev,;
	        kod1 WITH substr(Ret,AT(" ",Ret,2)+1,2),;
	        kod2 WITH substr(Ret,AT(" ",Ret,3)+1,2),;
	        kod3 WITH substr(Ret,AT(" ",Ret,4)+1,2),poloha WITH VAL(pol_cm)
	    ENDIF 
	    cislo=cislo+1
	    SELECT mapa
	ENDIF 
ENDSCAN 
***vymazani kurzoru mapa
ZAP 
SELECT objekty
***nahrada symbolu u TP 
SCAN   
    DO case
    CASE kod1="KP" OR kod1="LA" OR kod1="NA" OR kod1="TU" OR kod1="VP" OR kod1="VV" ;
    OR kod1="UD" OR kod1="MO" OR kod1="--" OR kod1="KO" OR kod1="P-" OR kod1="M-";
    OR kod1="C1" OR kod1="C5" OR kod1="C8" OR kod1="ST" OR kod1="ZV" 
    && zmna sla koleje v pmm smru
    case kod1="OS"
        replace kod1 WITH "VV"
    case kod1="ZS"
        replace kod1 WITH "VV"
    case kod1="OJ"
        replace kod1 WITH "VV"
    case kod1="ZJ"
        replace kod1 WITH "VV"   
    case kod1="DN"
        replace kod1 WITH "VP"
    case kod1="DM"
        replace kod1 WITH "VP"
    case kod1="DE"
        replace kod1 WITH "VP"
    case kod1="SP"
        replace kod1 WITH "TS"
    case kod1="DL"
        replace kod1 WITH "UD"
    case kod1="OH"
        replace kod1 WITH "OZ"
    case kod1="OV"
        replace kod1 WITH "OZ"
    case kod1="VY"
        replace kod1 WITH "VP"
    case kod1="ZP"
        replace kod1 WITH "ZA"
   OTHERWISE
   		BROWSE 
    ENDCASE 
    **********
    DO case
    CASE kod2="KP" OR kod2="LA" OR kod2="NA" OR kod2="TU" OR kod2="VP" OR kod2="VV" ;
    	OR kod2="UD" OR kod2="MO" OR kod2="--" OR kod2="KO" OR kod2="P-" OR kod2="M-";
    	OR kod2="C1" OR kod2="C5" OR kod2="C8" OR kod2="ST" OR kod2="ZV"
    case kod2="OS"
        replace kod2 WITH "VV"
    case kod2="ZS"
        replace kod2 WITH "VV"
    case kod2="OJ"
        replace kod2 WITH "VV"
    case kod2="ZJ"
        replace kod2 WITH "VV"   
    case kod2="DN"
        replace kod2 WITH "VP"
    case kod2="DM"
        replace kod2 WITH "VP"
    case kod2="DE"
        replace kod2 WITH "VP"
    case kod2="SP"
        replace kod2 WITH "TS"
    case kod2="DL"
        replace kod2 WITH "UD"
    case kod2="OH"
        replace kod2 WITH "OZ"
    case kod2="OV"
        replace kod2 WITH "OZ"
    case kod2="VY"
        replace kod2 WITH "VP"
    case kod2="ZP"
        replace kod2 WITH "ZA"
    OTHERWISE
   		BROWSE 
    ENDCASE 
    ************
    DO CASE
    CASE kod3="KP" OR kod3="LA" OR kod3="NA" OR kod3="TU" OR kod3="VP" OR kod3="VV" ;
    	OR kod3="UD" OR kod3="MO" OR kod3="--" OR kod3="KO" OR kod3="P-" OR kod3="M-";
    	OR kod3="C1" OR kod3="C5" OR kod3="C8" OR kod3="ST" OR kod3="ZV"
    case kod3="OS"
        replace kod3 WITH "VV"
    case kod3="ZS"
        replace kod3 WITH "VV"
    case kod3="OJ"
        replace kod3 WITH "VV"
    case kod3="ZJ"
        replace kod3 WITH "VV"   
    case kod3="DN"
        replace kod3 WITH "VP"
    case kod3="DM"
        replace kod3 WITH "VP"
    case kod3="DE"
        replace kod3 WITH "VP"
    case kod3="SP"
        replace kod3 WITH "TS"
    case kod3="DL"
        replace kod3 WITH "UD"
    case kod3="OH"
        replace kod3 WITH "OZ"
    case kod3="OV"
        replace kod3 WITH "OZ"
    case kod3="VY"
        replace kod3 WITH "VP"
    case kod3="ZP"
        replace kod3 WITH "ZA"
    OTHERWISE
   		BROWSE 
    ENDCASE 
ENDSCAN

**prevod udaju z tabulky objekty do tabulky radek
Zapsat=.F.
Nazev=""
SCAN
    IF NOT Nazev=ALLTRIM(soubor)
        Zapsat=.T.
    ENDIF 
    Nazev=ALLTRIM(soubor)
    Stozar=objekt
    IF LEN(alltrim(objekt))=3 && ml by bt roven tyem
        IF "HRU"$objekt
            Stozar="HRUS"
        ELSE 
            Stozar="0"+ALLTRIM(objekt)
        ENDIF
    ENDIF 
    D_cm=ALLTRIM(str(draha))
    K1=kod1
    K2=kod2
    K3=kod3
    Km=ALLTRIM(str(poloha))
    SELECT mapa
    IF Zapsat
        APPEND BLANK
        replace radek WITH nazev
        Zapsat=.F.
    ENDIF 
    APPEND BLANK
    replace radek with Stozar+" "+D_cm+" "+K1+" "+K2+" "+K3+" "+Km
    SELECT objekty
ENDSCAN
SELECT mapa
APPEND BLANK
replace radek WITH ":"
AktMapy=PUTFILE("Referenn data", "RefData", "MAP")
BROWSE 
IF NOT EMPTY(AktMapy)
	COPY TO (AktMapy) FIELDS radek DELIMITED WITH ""
ENDIF 
USE
SELECT objekty
USE 
ENDPROC 

PROCEDURE PridatZaznamDoMapy
	APPEND BLANK
	DO CASE 
		CASE nPrvni<10
			sPrvni="00000"+ALLTRIM(STR(nPrvni))
		CASE nPrvni<100
			sPrvni="0000"+ALLTRIM(STR(nPrvni))
		CASE nPrvni<1000
			sPrvni="000"+ALLTRIM(STR(nPrvni))
		CASE nPrvni<10000
			sPrvni="00"+ALLTRIM(STR(nPrvni))
		CASE nPrvni<100000
			sPrvni="0"+ALLTRIM(STR(nPrvni))
	ENDCASE
	replace objekt WITH sPrvni, draha WITH 5000, ;
		kod1 WITH K1, kod2 WITH "--", kod3 WITH "--",;
		poloha WITH 0, soubor WITH NazevUseku	
	K1="--"
ENDPROC 	
	
PROCEDURE sudeLiche
LOCAL neniCislo,pozice,str1,str2,pObjekt,strCislo
	neniCislo=.T.
	LavMostNadj=.F.
	pozice=1
	STORE "" TO str1,str2,pObjekt,strCislo
	IF (verze=4)
		DO WHILE neniCislo .AND. pozice<=4
			IF (NOT ISDIGIT(SUBSTR(objekt,pozice,1))) .OR. SUBSTR(objekt,pozice,1)="0"
				DO CASE  
					CASE SUBSTR(objekt,pozice,1)='M'
						most=most+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(most))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='L'
						lavka=lavka+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(lavka))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='N'
						nadjezd=nadjezd+1	
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(nadjezd))
						pozice=pozice+1
						neniCislo=.F.
					OTHERWISE 
						str1=str1+SUBSTR(objekt,pozice,1)
				ENDCASE 
				pozice=pozice+1
			ELSE
				strCislo=ALLTRIM(STR(VAL(SUBSTR(objekt,pozice))-1))
				*** v ppad, e se mn nap. 100 na 99, je nutn pidat 0 (099) ***
				IF LEN(strCislo)<LEN(ALLTRIM(STR(VAL(SUBSTR(objekt,pozice)))))
					str1=str1+"0"
				ENDIF
				neniCislo=.F.	
				pozice=pozice+1	
			ENDIF 
		ENDDO
	ELSE 
		DO WHILE neniCislo .AND. pozice<=6
				IF (NOT ISDIGIT(SUBSTR(objekt,pozice,1))) .OR. SUBSTR(objekt,pozice,1)="0"
					DO CASE  
						CASE SUBSTR(objekt,pozice,1)='M'
							most=most+1
							str1=str1+SUBSTR(objekt,pozice,1)+"-"
							strCislo=ALLTRIM(STR(most))
							pozice=pozice+1
							neniCislo=.F.
						CASE SUBSTR(objekt,pozice,1)='L'
							lavka=lavka+1
							str1=str1+SUBSTR(objekt,pozice,1)+"-"
							strCislo=ALLTRIM(STR(lavka))
							pozice=pozice+1
							neniCislo=.F.
						CASE SUBSTR(objekt,pozice,1)='N'
							nadjezd=nadjezd+1	
							str1=str1+SUBSTR(objekt,pozice,1)+"-"
							strCislo=ALLTRIM(STR(nadjezd))
							pozice=pozice+1
							neniCislo=.F.
						OTHERWISE 
							str1=str1+SUBSTR(objekt,pozice,1)
					ENDCASE 
					pozice=pozice+1
				ELSE
					strCislo=ALLTRIM(STR(VAL(SUBSTR(objekt,pozice))-1))
					*** v ppad, e se mn nap. 100 na 99, je nutn pidat 0 (099) ***
					IF LEN(strCislo)<LEN(ALLTRIM(STR(VAL(SUBSTR(objekt,pozice)))))
						str1=str1+"0"
					ENDIF
					neniCislo=.F.	
					pozice=pozice+1	
				ENDIF 
		ENDDO
	ENDIF   
	   
	pozice=pozice-1
	&& za cislem jeste nasleduje nejaky znak
	IF (verze=4)
		IF pozice+LEN(strCislo)<4
			str2=ALLTRIM(SUBSTR(objekt,pozice+LEN(strCislo)+1))
		ENDIF
	ELSE 
		IF pozice+LEN(strCislo)<6
			str2=ALLTRIM(SUBSTR(objekt,pozice+LEN(strCislo)+1))
		ENDIF
	ENDIF  
	IF NOT strCislo="-1"
		pObjekt=str1+strCislo+str2
		replace objekt WITH pObjekt
	ENDIF 
ENDPROC 

PROCEDURE licheSude
LOCAL neniCislo,pozice,str1,str2,pObjekt,strCislo
	neniCislo=.T.
	LavMostNadj=.F.
	pozice=1
	STORE "" TO str1,str2,pObjekt,strCislo
	IF (verze=4)
		DO WHILE neniCislo .AND. pozice<=4
			IF (NOT ISDIGIT(SUBSTR(objekt,pozice,1))) .OR. SUBSTR(objekt,pozice,1)="0"
				DO CASE  
					CASE SUBSTR(objekt,pozice,1)='M'
						most=most+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(most))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='L'
						lavka=lavka+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(lavka))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='N'
						nadjezd=nadjezd+1	
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(nadjezd))
						pozice=pozice+1
						neniCislo=.F.
					OTHERWISE 
						str1=str1+SUBSTR(objekt,pozice,1)
				ENDCASE 
				pozice=pozice+1
			ELSE
				strCislo=ALLTRIM(STR(VAL(SUBSTR(objekt,pozice))+1))
				*** v ppad, e se mn nap. 99 na 100, je teba zkrtit str1 o prvni znak ***
				IF LEN(strCislo)>LEN(ALLTRIM(STR(VAL(SUBSTR(objekt,pozice)))))
					str1=SUBSTR(str1,2)
					pozice=pozice-1
				ENDIF
				neniCislo=.F.		
			ENDIF 
		ENDDO
	ELSE 
		DO WHILE neniCislo .AND. pozice<=6
			IF (NOT ISDIGIT(SUBSTR(objekt,pozice,1))) .OR. SUBSTR(objekt,pozice,1)="0"
				DO CASE  
					CASE SUBSTR(objekt,pozice,1)='M'
						most=most+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(most))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='L'
						lavka=lavka+1
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(lavka))
						pozice=pozice+1
						neniCislo=.F.
					CASE SUBSTR(objekt,pozice,1)='N'
						nadjezd=nadjezd+1	
						str1=str1+SUBSTR(objekt,pozice,1)+"-"
						strCislo=ALLTRIM(STR(nadjezd))
						pozice=pozice+1
						neniCislo=.F.
					OTHERWISE 
						str1=str1+SUBSTR(objekt,pozice,1)
				ENDCASE 
				pozice=pozice+1
			ELSE
				strCislo=ALLTRIM(STR(VAL(SUBSTR(objekt,pozice))+1))
				*** v ppad, e se mn nap. 99 na 100, je teba zkrtit str1 o prvni znak ***
				IF LEN(strCislo)>LEN(ALLTRIM(STR(VAL(SUBSTR(objekt,pozice)))))
					str1=SUBSTR(str1,2)
					pozice=pozice-1
				ENDIF
				neniCislo=.F.		
			ENDIF 
		ENDDO
	ENDIF    
	pozice=pozice-1
	&& za cislem jeste nasleduje nejaky znak
	IF (verze=4)
		IF pozice+LEN(strCislo)<4
			str2=ALLTRIM(SUBSTR(objekt,pozice+LEN(strCislo)+1))
		ENDIF 
	ELSE 
		IF pozice+LEN(strCislo)<6
			str2=ALLTRIM(SUBSTR(objekt,pozice+LEN(strCislo)+1))
		ENDIF
	ENDIF  
	replace objekt WITH str1+strCislo+str2
ENDPROC 


PROCEDURE Mapa
	STORE "" TO pol_cm, Nazev, R_kmh, Stozar
*	SET COMPATIBLE ON
*	IF FILE(MemoCestaCDuseky)
*		SELECT 0
*		USE (MemoCestaCDuseky) ALIAS nazevCDuseku
*		SELECT * FROM nazevCDuseku INTO CURSOR Suseky ORDER BY soubor READWRITE 
*		SET COLLATE TO "CZECH"
*		INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*		SELECT nazevCDuseku
*		USE
*	ELSE 
*		IF FILE((cCestaProgramu)+"\Tables\CDuseky.dbf")
*			USE ((cCestaProgramu)+"\Tables\CDuseky.dbf")
*			SELECT * FROM CDuseky INTO CURSOR Suseky ORDER BY soubor READWRITE 
*			SET COLLATE TO "CZECH"
*			INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*			SELECT CDuseky
*			USE
*		ELSE
*			MESSAGEBOX("Nebyl nalezen soubor GPT_tisk_protokolu\Tables\CDuseky.dbf")
*		ENDIF 
*	ENDIF 
*	SET COMPATIBLE OFF
	
*	IF FILE(cCestaProgramu+"\Tables\CDuseky.dbf")
*		SELECT * FROM (cCestaProgramu)+"\Tables\CDuseky.dbf" INTO CURSOR Suseky ORDER BY soubor READWRITE 
*		SET COLLATE TO "CZECH"
*		INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*		SELECT CDuseky
*		USE 
*	ELSE 
*		=MESSAGEBOX("Seznam sek nenalezen. Zkopruj soubor CDuseky.dbf do adrese Tables.")
*	ENDIF 
	
	SELECT mapa
	GO TOP 
	SCAN 
		IF ("HRU"$radek .OR. ":"$radek)
		ELSE
			R=ALLTRIM(Radek) 
			EXIT 
		ENDIF 
	ENDSCAN 
	SELECT mapa
	GO TOP

	IF (LEN(LEFT(R,ATC(" ",R,1)-1))=4)
		verze=4
		CREATE CURSOR objekty (por_cis n(6), objekt c(4), draha n(8), kod1 c(2), kod2 c(2),;
		kod3 c(2), poloha n(11,2), soubor c(99))
	ELSE 
		verze=6
		CREATE CURSOR objekty (por_cis n(6), objekt c(6), draha n(8), kod1 c(2), kod2 c(2),;
		kod3 c(2), poloha n(11,2), soubor c(99))
	ENDIF 
	SELECT mapa
	
	
	Cislo=1
	****prepsani hodnot z kurzoru mapa do kurzoru objekty
	SCAN
		IF LEFT(radek,1)=":"
			Nazev=ALLTRIM(Radek)
		ELSE
			Ret=ALLTRIM(Radek)
			SELECT objekty
			APPEND BLANK 
*			pol_cm=substr(Ret,AT(" ",Ret,5)+1,8)
			IF (verze=4)
				replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
					draha WITH VAL(SUBSTR(Ret,6,atc(" ",R,2)-6)),soubor WITH Nazev,;
					kod1 WITH substr(Ret,AT(" ",Ret,2)+1,2),;
					kod2 WITH substr(Ret,AT(" ",Ret,3)+1,2),;
					kod3 WITH substr(Ret,AT(" ",Ret,4)+1,2),;
					poloha	WITH VAL(substr(Ret,ATC(" ",Ret,5)+1))*100
*					poloha WITH VAL(pol_cm)*100
			ELSE
				IF (LEN(LEFT(Ret,AT(" ",Ret,1)-1))=4)
					replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
						draha WITH VAL(SUBSTR(Ret,8,atc(" ",R,4)-8)),soubor WITH Nazev,;
						kod1 WITH substr(Ret,AT(" ",Ret,4)+1,2),;
						kod2 WITH substr(Ret,AT(" ",Ret,5)+1,2),;
						kod3 WITH substr(Ret,AT(" ",Ret,6)+1,2),;
						poloha	WITH VAL(substr(Ret,ATC(" ",Ret,7)+1))*100
*						poloha WITH VAL(pol_cm)*100
				ELSE 
					replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
						draha WITH VAL(SUBSTR(Ret,8,atc(" ",R,2)-8)),soubor WITH Nazev,;
						kod1 WITH substr(Ret,AT(" ",Ret,2)+1,2),;
						kod2 WITH substr(Ret,AT(" ",Ret,3)+1,2),;
						kod3 WITH substr(Ret,AT(" ",Ret,4)+1,2),;
						poloha	WITH VAL(substr(Ret,ATC(" ",Ret,5)+1))*100
*						poloha WITH VAL(pol_cm)*100
				ENDIF 
			ENDIF 
			cislo=cislo+1
			SELECT mapa
		ENDIF 
	ENDSCAN 
***vymazani kurzoru mapa
	ZAP 
	SELECT objekty
***doplnovani udaju do tabulky objekty v rezimu browse
	BROWSE FIELDS por_cis, objekt, draha, kod1, kod2, kod3, poloha:H="poloha_cm ", soubor TITLE "Prochzen"
**prevod udaju z kurzoru objekty do kurzoru mapa
	GO TOP 
	Zapsat=.F.
	Draha_cm=draha
	**** do prvnho kdu KP se kilometrick poloha opisuje, od nj pak vypotv 
	poloha1=poloha
	SKIP 
	poloha2=poloha
	SKIP -1
	IF poloha1<poloha2
		Baze=poloha-Draha_cm
		Znamenko="P-"
	ELSE 
		Baze=poloha+Draha_cm
		Znamenko="M-"
	ENDIF 
	SCAN
		IF NOT Nazev=ALLTRIM(soubor)
			Zapsat=.T.
		ENDIF 
		IF kod1="KP" .OR. kod2="KP" .OR. kod3="KP"
			Km=poloha
			Baze=Km
			DO CASE 
				CASE kod1="P-" .OR. kod1="M-"
					Znamenko=kod1
				CASE kod2="P-" .OR. kod2="M-"
					Znamenko=kod2
				CASE kod3="P-" .OR. kod3="M-"
					Znamenko=kod3
				OTHERWISE
					Znamenko="--"
			ENDCASE 
		ELSE
			DO CASE 
				CASE Znamenko="P-"
					Km=Baze+(Draha_cm)
				CASE Znamenko="M-"
					Km=Baze-(Draha_cm)
				OTHERWISE
					Km=0
			ENDCASE
			Baze=Km
			replace poloha WITH km
		ENDIF
		
********
		Nazev=ALLTRIM(soubor)
		Draha_cm=draha	
		K1=kod1
		K2=kod2
		K3=kod3
		Stozar=objekt
		IF LEN(alltrim(objekt))=3
			IF "HRU"$objekt
				Stozar="HRUS"
			ELSE 
				Stozar="0"+ALLTRIM(objekt)
			ENDIF
		ENDIF 
		
********
		SELECT mapa
		IF Zapsat
			APPEND BLANK
			replace radek WITH nazev
			Zapsat=.F.
		ENDIF 
		APPEND BLANK
		Km=ALLTRIM(STR(ROUND(Km/100,0)))
		D_cm=ALLTRIM(STR(Draha_cm))
		replace radek with Stozar+" "+D_cm+" "+K1+" "+K2+" "+K3+" "+Km
		SELECT objekty
	ENDSCAN
	USE 
*	SELECT Suseky
*	USE 
***ulozeni udaju z kurzoru mapa do textove mapy
	SELECT mapa
	APPEND BLANK
	replace radek WITH ":"
	IF DIRECTORY(MemoCestaMap)
		SET DEFAULT TO (MemoCestaMap)
	ENDIF 
	AktMapy=putfile("Referenn data", "RefData","MAP")
	SET DEFAULT TO (cCestaProgramu)
	IF NOT EMPTY(AktMapy)
		MemoCestaMap=LEFT(AktMapy,RAT('\',AktMapy)-1)
		COPY TO (AktMapy) FIELDS radek DELIMITED WITH ""
	ENDIF 
	USE 
*	IF FILE(AktMapy)
*		MESSAGEBOX("Referenn data byla spn uloena.")
*	ELSE 
*		MESSAGEBOX("Referenn data nebyla uloena !!!")
*	ENDIF 
ENDPROC  

PROCEDURE Mapa_bez_km
	STORE "" TO Nazev, stozar
	Zapsat=.F.
	
*	SET COMPATIBLE ON
*	IF FILE(MemoCestaCDuseky)
*		SELECT 0
*		USE (MemoCestaCDuseky) ALIAS nazevCDuseku
*		SELECT * FROM nazevCDuseku INTO CURSOR Suseky ORDER BY soubor READWRITE 
*		SET COLLATE TO "CZECH"
*		INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*		SELECT nazevCDuseku
*		USE
*	ELSE 
*		IF FILE((cCestaProgramu)+"\Tables\CDuseky.dbf")
*			USE ((cCestaProgramu)+"\Tables\CDuseky.dbf")
*			SELECT * FROM CDuseky INTO CURSOR Suseky ORDER BY soubor READWRITE 
*			SET COLLATE TO "CZECH"
*			INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*			SELECT CDuseky
*			USE
*		ELSE
*			MESSAGEBOX("Nebyl nalezen soubor GPT_tisk_protokolu\Tables\CDuseky.dbf")
*		ENDIF 
*	ENDIF 
*	SET COMPATIBLE OFF
*	IF FILE(cCestaProgramu+"\Tables\CDuseky.dbf")
*		SELECT * FROM (cCestaProgramu)+"\Tables\CDuseky.dbf" INTO CURSOR Suseky ORDER BY soubor READWRITE 
*		SET COLLATE TO "CZECH"
*		INDEX ON soubor TAG soubor &&OF Suseky  (strukturovan soubor bez OF)
*		SELECT CDuseky
*		USE 
*	ELSE 
*		=MESSAGEBOX("Seznam sek nenalezen. Zkopruj soubor CDuseky.dbf do adrese Tables.")
*	ENDIF 
	CREATE CURSOR objekty (por_cis n(6), objekt c(4), draha n(8), kod1 c(2), kod2 c(2),;
		kod3 c(2), poloha n(11,2), soubor c(99))

	SELECT mapa
	Cislo=1
	****prepsani hodnot z kurzoru mapa do kurzoru objekty
	SCAN
		IF LEFT(radek,1)=":"
			Nazev=ALLTRIM(Radek)
		ELSE
			Ret=ALLTRIM(Radek)
			SELECT objekty
			APPEND BLANK 
			pol_cm=substr(Ret,AT(" ",Ret,5)+1,8)
			replace por_cis WITH Cislo,objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
				draha WITH VAL(substr(Ret,AT(" ",Ret,1)+1,4)),soubor WITH Nazev,;
				kod1 WITH substr(Ret,AT(" ",Ret,2)+1,2),;
				kod2 WITH substr(Ret,AT(" ",Ret,3)+1,2),;
				kod3 WITH substr(Ret,AT(" ",Ret,4)+1,2),poloha WITH VAL(pol_cm)*100
			cislo=cislo+1
			SELECT mapa
		ENDIF 
	ENDSCAN 
***vymazani kurzoru mapa
	ZAP 
	SELECT objekty
**prevod udaju z kurzoru objekty do kurzoru mapa
	GO TOP 
	SCAN
		IF NOT Nazev=ALLTRIM(soubor)
			Zapsat=.T.
		ENDIF 
		IF Stozar="HRUS"
			K1="KP"
		ELSE 
			K1="--"
		ENDIF 
		K2="--"
		K3="--"
		Nazev=ALLTRIM(soubor)
		Stozar=objekt
		IF LEN(alltrim(objekt))=3
			IF "HRU"$objekt
				Stozar="HRUS"	
			ELSE 
				Stozar="0"+ALLTRIM(objekt)
			ENDIF
		ENDIF 
	
		Draha_cm=draha	
		Km="0"
		SELECT mapa
		IF Zapsat
			APPEND BLANK
			replace radek WITH nazev
			Zapsat=.F.
		ENDIF
		APPEND BLANK
		D_cm=ALLTRIM(STR(Draha_cm))
		replace radek with Stozar+" "+D_cm+" "+K1+" "+K2+" "+K3+" "+Km
		SELECT objekty
	ENDSCAN
	USE 
*	SELECT Suseky
*	USE 
	***ulozeni udaju z  tabulky radek do textove mapy
	SELECT mapa
	APPEND BLANK
	replace radek WITH ":"
	IF DIRECTORY(MemoCestaMap)
		SET DEFAULT TO (MemoCestaMap)
	ENDIF 
	AktMapy=putfile("Referenn data", "RefData","MAP")
	SET DEFAULT TO (cCestaProgramu)
	IF NOT EMPTY(AktMapy)
		MemoCestaMap=LEFT(AktMapy,RAT('\',AktMapy)-1)
		COPY TO (AktMapy) FIELDS radek DELIMITED WITH ""
	ENDIF 
	USE 
	IF FILE(AktMapy)
		MESSAGEBOX("Referenn data byla spn uloena.")
	ELSE 
		MESSAGEBOX("Referenn data nebyla uloena !!!")
	ENDIF 
ENDPROC  


PROCEDURE Otevri
	IF MESSAGEBOX("Odstranit vechny zznamy ?",36,"Men GPT")=6
		SELECT GptEvTras
		ZAP 
		SELECT GptInfo
		ZAP 
	ENDIF 
	IF DIRECTORY(MemoCestaSestav)&&NOT EMPTY(MemoCestaSestav) &&FILE(MemoCestaSestav)
		SET DEFAULT TO (MemoCestaSestav)
	ENDIF 	
	OtevriInfo=getfile("DBF", "InfoTrasy")
	SET DEFAULT TO (cCestaProgramu)
	IF NOT EMPTY(OtevriInfo)
		MemoCestaSestav=LEFT(OtevriInfo,RAT('\',OtevriInfo)-1)
		HIDE window gptinfo
		APPEND FROM (OtevriInfo)
		COUNT TO Mereno FOR NOT EMPTY(Datum_cas)
		COUNT TO Nemereno FOR EMPTY(datum_cas)
		SUM draha_konc TO DelkaKm
		OtevriInfo=LEFT(OtevriInfo,LEN(OtevriInfo)-1)
		SELECT gptevtras
		APPEND FROM (OtevriInfo)
		SELECT gptinfo
		replace info WITH ALLTRIM(STR(RECNO())) all
		GO top
		SHOW window gptinfo REFRESH top
	ENDIF
	SET DEFAULT TO (cCestaProgramu)
ENDPROC 

PROCEDURE Uloz
*	SET ORDER TO
	OldFilter=FILTER()
	IF LEN(FILTER())>0
		IF MESSAGEBOX("Zruit filtr pi ukldn Infosek ?",36,"Men GPT")=6
			SET FILTER TO
		ENDIF
	ENDIF 
*	OldFilter=FILTER()
*	IF NOT OldFilter=""
*		IF MESSAGEBOX("Zruit filtr ?",36,"Men GPT")=6
*			SET FILTER TO
*		ENDIF 
*	ENDIF 
	IF DIRECTORY(MemoCestaSestav)&&NOT EMPTY(MemoCestaSestav) &&FILE(MemoCestaSestav)
		SET DEFAULT TO (MemoCestaSestav)
	ENDIF 	
	UlozInfo=PUTFILE("Info seky","InfoUseky","dbf")
	SET DEFAULT TO (cCestaProgramu)
	IF NOT EMPTY(UlozInfo)
		MemoCestaSestav=LEFT(UlozInfo,RAT('\',UlozInfo)-1)
		COPY to (UlozInfo)
		UlozInfo=LEFT(UlozInfo,LEN(UlozInfo)-1)
		SELECT gptevtras
		COPY TO (UlozInfo)
		SELECT gptinfo
	ENDIF 
	SET filter TO &OldFilter
	RETURN 
ENDPROC 

PROCEDURE OtevriTrasu
*	RELEASE WINDOWS 
*	HIDE window cduseky
	CURSORSETPROP('Buffering', 1, 'Suseky')
	SET MULTILOCKS OFF
	SET EXCLUSIVE ON 
	IF DIRECTORY(MemoCestaTras)&&NOT EMPTY(MemoCestaSestav) &&FILE(MemoCestaSestav)
		SET DEFAULT TO (MemoCestaTras)
	ENDIF 	
	OtevriTrasu=getfile("DBF", "Trasa")
	SET DEFAULT TO (cCestaProgramu)
	IF NOT EMPTY(OtevriTrasu)
		MemoCestaTras=LEFT(OtevriTrasu,RAT('\',OtevriTrasu)-1)
		SELECT 0
		USE (OtevriTrasu) ALIAS trasa EXCLUSIVE 
		SELECT s.typ_useku, s.nazev, t.soubor, s.odkud, s.kam, s.kolej, s.or, s.otv, s.info, s.max_rychl, s.trat, s.cis_trate, s.proj_vyska FROM trasa t LEFT JOIN suseky s ON t.soubor=s.soubor WHERE t.info='H' INTO CURSOR suseky READWRITE 
*		INDEX on soubor TAG soubor
		SELECT trasa 
		USE 
	ENDIF
	SELECT suseky
	SET MULTILOCKS ON
	CURSORSETPROP('Buffering', 5, 'Suseky') 
*	TABLEUPDATE()
*	SET MULTILOCKS ON
*	CURSORSETPROP('Buffering', 5, 'Suseky') &&
*	SHOW window cduseky REFRESH top
*	DO FORM ((cCestaProgramu)+"\forms\cduseky.scx")
ENDPROC

PROCEDURE kontrolaKmPolohy
	SELECT tp, kolej, km_poloha, soubor FROM kmpoloha WHERE NOT EMPTY(km_poloha) INTO CURSOR pouzeKmPolohy READWRITE 
	INDEX on soubor TAG soubor
	CREATE CURSOR objekty (por_cis n(6), objekt c(4), draha n(8), kod1 c(2), kod2 c(2), kod3 c(2), poloha n(7,3), soubor c(99))
	cislo=1
	SELECT mapa
	GO TOP 
	SCAN
		IF LEFT(radek,1)=":"
			IF (ALLTRIM(Radek)=":Konecmereni")
				EXIT  
			ELSE 
				Nazev=ALLTRIM(Radek)
			ENDIF 
		ELSE
			Ret=ALLTRIM(Radek)
			SELECT objekty
			APPEND BLANK 
			replace por_cis WITH Cislo,;
					objekt WITH LEFT(Ret,AT(" ",Ret,1)-1),;
					draha WITH VAL(substr(Ret,AT(" ",Ret,1)+1,4)),;
					kod1 WITH substr(Ret,AT(" ",Ret,2)+1,2),;
					kod2 WITH substr(Ret,AT(" ",Ret,3)+1,2),;
					kod3 WITH substr(Ret,AT(" ",Ret,4)+1,2),;
					poloha WITH (VAL(substr(Ret,AT(" ",Ret,5)+1,8)))/1000,;
					soubor WITH substr(Nazev,2,RAT(" ",Nazev,1)-2)
			cislo=cislo+1
			SELECT mapa
		ENDIF 
	ENDSCAN 
	SELECT o.soubor, o.objekt, o.poloha as kmp_mapa, pkp.km_poloha as kmp_cdus, pkp.kolej FROM objekty o LEFT JOIN pouzeKmPolohy pkp ON (ALLTRIM(pkp.soubor)=ALLTRIM(o.soubor) AND ALLTRIM(pkp.tp)=ALLTRIM(o.objekt)) INTO CURSOR porovnani READWRITE 
	SELECT porovnani
	REPORT FORM (cCestaProgramu)+"\reports\porovnani_km_polohy.frx" FOR NOT EMPTY(soubor) AND ABS(kmp_cdus-kmp_mapa)>(TolKmPol) PREVIEW 
	SET SYSMENU ON 
ENDPROC 
		